SystemOrganization addCategory: #'Mabinogi-Core'!
SystemOrganization addCategory: #'Mabinogi-Core-Persistence'!
SystemOrganization addCategory: #'Mabinogi-Core-Commands'!

Error subclass: #MbValidationError
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

MbValidationError subclass: #MbRequiredFieldError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRequiredFieldError methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:06'!
message
	^'{1} is required' format: { definition label }! !

!MbValidationError class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:03'!
signalForDefintion: aDefinition
	self new
		setDefinition: aDefinition;
		signal! !

!MbValidationError methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:57'!
message
	^'{1} invalid' format: { definition label }! !

!MbValidationError methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:57'!
setDefinition: aDefinition
	definition := aDefinition! !

Object subclass: #MbCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Commands'!

!MbCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:53'!
canUndo
	"Indicates whether or not this command can be undone"
	^true! !

!MbCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 16:10'!
description
	^self class name! !

!MbCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:46'!
do
	"Performs the action"! !

!MbCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:46'!
undo
	"Restore the model to its previous state"! !

MbCommand subclass: #MbSimpleCommand
	instanceVariableNames: 'doBlock undoBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Commands'!

!MbSimpleCommand class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:08'!
do: aBlock
	^self do: aBlock undo: nil! !

!MbSimpleCommand class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:52'!
do: aDoBlock undo: anUndoBlock
	^self basicNew
		initializeWithDo: aDoBlock undo: anUndoBlock;
		yourself! !

!MbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:54'!
canUndo
	^undoBlock notNil! !

!MbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:53'!
do
	doBlock value! !

!MbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:53'!
initializeWithDo: aDoBlock undo: anUndoBlock
	self initialize.
	doBlock := aDoBlock.
	undoBlock := anUndoBlock! !

!MbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 13:53'!
undo
	undoBlock value! !

Object subclass: #MbCommandProcessor
	instanceVariableNames: 'history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Commands'!

!MbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:52'!
canUndo
	^history notEmpty! !

!MbCommandProcessor methodsFor: 'accessing' stamp: 'StuartHerring 1/22/2012 15:53'!
history
	^history! !

!MbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:37'!
history: aCollection
	"Replace the internal history collection with an external one"
	history := aCollection.! !

!MbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:54'!
initialize
	super initialize.
	history := OrderedCollection new.! !

!MbCommandProcessor methodsFor: 'actions' stamp: 'StuartHerring 2/5/2012 17:08'!
invoke: aCommand
	aCommand do.
	history addFirst: aCommand
! !

!MbCommandProcessor methodsFor: 'actions' stamp: 'StuartHerring 2/1/2012 21:20'!
undo
	history removeFirst
		undo! !

MbCommandProcessor subclass: #MbTransactionalCommandProcessor
	instanceVariableNames: 'transactionProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Persistence'!

!MbTransactionalCommandProcessor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/4/2012 14:13'!
transactionProvider: aTransactionProvider
	^self basicNew
		initializeWithTransactionProvider: aTransactionProvider;
		yourself.! !

!MbTransactionalCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/4/2012 14:13'!
initializeWithTransactionProvider: aTransactionProvider.
	self initialize.
	transactionProvider := aTransactionProvider! !

!MbTransactionalCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:08'!
invoke: aCommand
	transactionProvider commit: [
		super invoke: aCommand ]! !

!MbTransactionalCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:09'!
undo
	transactionProvider commit: [ super undo ]! !

Object subclass: #MbDefinition
	instanceVariableNames: 'label required formatter rules selector model typeHint renderHint valuesBlock precision currency ignored'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbDefinition commentStamp: 'StuartHerring 1/7/2012 13:58' prior: 0!
I represent the defintion of a field within an object and present the additional meta-information required to enable automatic validation and presentation of the field.!

!MbDefinition class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:34'!
selector: aSelector 
	^self basicNew
		initializeWithSelector: aSelector;
		yourself! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:59'!
assertValid: aValue
	[required ifTrue: [ MbRequiredRule new assertValid: aValue ].
		aValue ifNotNil: [ rules do: [ :r | r assertValid: aValue ]]] 
	on: MbValidationError do: [ :e | e setDefinition: self; signal ]! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:21'!
currency 
	^currency! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:15'!
currency: aCurrencySymbol
	currency := aCurrencySymbol.
	formatter := [ :v | '{1} {2}' format: {aCurrencySymbol asString. v printAsCurrency}].
	self numeric: 2! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:27'!
date: aBoolean
	aBoolean
		ifTrue: [ 
			self typeHint: #date.
			rules add:
					(MbRule
						validationBlock: [ :v | 
							[ v asDate ] on: Error do: [ :err | MbValidationError signalForDefintion: self ] ]).
			self renderHint: #datePicker ]! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:42'!
ignore: aValue
	ignored := true! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:42'!
ignored
	^ignored! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:28'!
initializeWithSelector: aSelector
	self initialize.
	selector := aSelector.
	label := aSelector asCapitalizedPhrase.
	required := false.
	rules := OrderedCollection new.
	typeHint := #string.
	precision := nil.
	ignored := false.
	formatter := [ :v | v asString ]! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/11/2012 10:32'!
label
	^label! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2012 16:55'!
label: aLabel
	label := aLabel! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:05'!
modelValue
	^model perform: selector! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:34'!
numeric: aBooleanOrNumber
	self typeHint: #numeric.
	rules add: (MbRule validationBlock: [ :v | [v asNumber] on: Error do: [ :err | MbValidationError signalForDefintion: self ] ]).
	aBooleanOrNumber isNumber ifTrue: [
		precision := aBooleanOrNumber].! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:18'!
precision
	^precision! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:14'!
printValue
	^formatter value: self modelValue! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:41'!
renderHint
	^renderHint! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:41'!
renderHint: aSymbol
	renderHint := aSymbol! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:36'!
required
	^required! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:39'!
required: aBoolean
	required := aBoolean.! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:38'!
selector
	^selector! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 08:30'!
setModel: anObject
	model := anObject! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:09'!
setModelValue: aValue
	model perform: selector asMutator with: aValue! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:38'!
typeHint
	^typeHint! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:38'!
typeHint: aSymbol
	typeHint := aSymbol! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:07'!
valueSelector: aSymbol
	valuesBlock := [model perform: aSymbol].
	rules add: (MbRestrictedValueRule valuesBlock: valuesBlock).
	self renderHint: #dropDown! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:07'!
values
	^valuesBlock value! !

Object subclass: #MbObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:45'!
mbDefinitionFor: aField
	| method |
	method := self lookupSelector: aField.
	^ method category = self mbFieldCategory
		ifFalse: [ nil ]
		ifTrue: [ 
			method pragmas
				inject: (MbDefinition selector: aField)
				into: [ :def :p | 
					[ 
					p numArgs > 0
						ifTrue: [ p sendTo: def ]
						ifFalse: [ def perform: p keyword asMutator with: true ] ]
						on: MessageNotUnderstood
						do: [ :err |  ].	"Assume unknown pragmas aren't for us"
					def ignored ifTrue: [nil] ifFalse: [def]] ]! !

!MbObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:24'!
mbDefinitions
	^(self mbSelectors)
		collect: [ :s | self mbDefinitionFor: s ] 
		thenSelect: [ :def | def notNil]! !

!MbObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:49'!
mbFieldCategory
	^'accessing'! !

!MbObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:53'!
mbSelectors
	| currentClass selectors |
	selectors := Set new.
	currentClass := self.
	[ currentClass inheritsFrom: MbObject ] whileTrue: [
		selectors addAll: (currentClass selectorsWithArgs: 0).
		currentClass := currentClass superclass].
	^selectors! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:01'!
isEmptyOrNil
	^false! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:27'!
mbDefinitionFor: aSymbol
	^(self class mbDefinitionFor: aSymbol)
		setModel: self; 
		yourself! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:26'!
mbDefinitions
	^(self class mbDefinitions)
		collect: [ :s | s setModel: self ] ! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 08:27'!
set: aField to: aValue
	(self mbDefinitionFor: aField) 
		assertValid: aValue.
	self instVarNamed: aField put: aValue! !

Object subclass: #MbRule
	instanceVariableNames: 'validationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

MbRule subclass: #MbRequiredRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRequiredRule class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:04'!
new
	^self validationBlock: [ :aValue |
			(aValue isNil or: [ aValue isCollection and: [ aValue isEmpty]]) ifTrue: [ MbRequiredFieldError signal ]]! !

MbRule subclass: #MbRestrictedValueRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRestrictedValueRule class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:05'!
valuesBlock: valuesBlock
	^self validationBlock: [ :aValue |
	(valuesBlock value includes: aValue) ifFalse: [ MbValidationError signal ]]! !

!MbRule class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:02'!
validationBlock: aBlock
	^self basicNew
		initializeWithBlock: aBlock;
		yourself! !

!MbRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:01'!
assertValid: aValue
	validationBlock value: aValue.! !

!MbRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:02'!
initializeWithBlock: aBlock
	self initialize.
	validationBlock := aBlock.! !

Object subclass: #MbTransactionProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Persistence'!

!MbTransactionProvider methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/4/2012 14:16'!
begin
! !

!MbTransactionProvider methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/4/2012 14:16'!
commit
! !

!MbTransactionProvider methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 15:33'!
commit: aBlock
	self begin.
	[ aBlock value ] on: Error do: [ :e |
		self rollback.
		e signal	].
	self commit! !

!MbTransactionProvider methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/4/2012 14:16'!
rollback! !
